#include "ROctave.h"

#ifdef eval
#undef eval
#endif

#include <octave/oct.h>
#include <octave/ov-base.h>
#include <octave/ov-scalar.h>
#include <octave/pt-fcn.h>

extern "C" {

USER_OBJECT_
R_OctaveCall(USER_OBJECT_ funcName, USER_OBJECT_ args)
{
  int i, n;
  tree_fvc *f;
  octave_value ans;
  octave_value_list argList;
  f = is_valid_function(CHAR_DEREF(STRING_ELT(funcName, 0)), "?", 1);
  if(!f) {
    PROBLEM "problem calling Octave function"
    ERROR;
  }
  n = GET_LENGTH(args);
  for(i = 0; i < n; i++)
    argList(i) = toOctaveValue(VECTOR_ELT(args, i));

  octave_value_list val = f->eval(0, 1, argList); 

  if(val.length() > 0 && val(0).is_defined())
    return(toRValue(val(0)));

  return(NULL_USER_OBJECT);
}

}


DEFUN_DLD(OctaveCall, args, , "call an Octave function")
{
  tree_fvc *f;
  octave_value ans;
  octave_value_list argList;
  f = is_valid_function(args(0), "callFun", 1);
  octave_value_list val = f->eval(0, 1, argList);

  if(val.length() > 0 && val(0).is_defined())
    return(val(0));

  return(ans);
}


#if 1

extern "C" {
  void InitializeOctave(int argc, char **argv);
}

USER_OBJECT_
R_initOctave(USER_OBJECT_ args)
{
  char **argv;
  int n, i;
  USER_OBJECT_ ans = NEW_INTEGER(1);
  n = GET_LENGTH(args);
  argv = (char **) malloc(n * sizeof(char **));
  for(i = 0; i < n; i++) {
    argv[i] = strdup(CHAR_DEREF(STRING_ELT(args, i)));
  }

  InitializeOctave(n, argv);
  INTEGER_DATA(ans)[0] = 1;
  return(ans);
}

#endif

